package com.objis.demohibernate.domaine;

import java.util.Date;
import java.util.Set;

/**
 * @author Douglas MBIANDOU (www.objis.com)
 * Classe mtier Formation.
 */
public class Formation {

	private Long id; // Identifiant (Cl primaire) de la formation (Objis !) choisie. 
	private String theme; // Thme formation
	private Date dateDebut; // Date dbut formation
	private int duree; // Dure formation
	private Lieu lieu; // Lieu de la formation
	private Set<Formateur> formateurs; // Formateurs
	
	/**
	 * Constructeur sans argument. 
	 * Ncessaire pour chargement d'Objets (ex: session.load(). Gnration Proxy.
	 * Sinon Exception type InstantiationException: 
	 * com.objis.demohibernate.complexe.Formation_$$_javassist_1
	 */
	public Formation() {
		super();
	}

	public Formation(String theme, Date dateDebut, int duree, Lieu lieu) {
		super();
		this.theme = theme;
		this.dateDebut = dateDebut;
		this.duree = duree;
		this.lieu = lieu;
	}
	// Getters & Setters
	public Date getDateDebut() {
		return dateDebut;
	}

	public void setDateDebut(Date dateDebut) {
		this.dateDebut = dateDebut;
	}

	public Lieu getLieu() {
		return lieu;
	}

	public void setLieu(Lieu lieu) {
		this.lieu = lieu;
	}

	public Date getDataDebut() {
		return dateDebut;
	}

	public void setDataDebut(Date dateDebut) {
		this.dateDebut = dateDebut;
	}

	public int getDuree() {
		return duree;
	}

	public void setDuree(int duree) {
		this.duree = duree;
	}

	// Getters et Setters
	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getTheme() {
		return theme;
	}

	public void setTheme(String theme) {
		this.theme = theme;
	}

	public Set<Formateur> getFormateurs() {
		return formateurs;
	}

	public void setFormateurs(Set<Formateur> formateurs) {
		this.formateurs = formateurs;
	}
	
	// Constructeur
	public Formation(String theme) {
		super();
		this.theme = theme;
	}

	public Formation(String theme, Date dateDebut, int duree, Lieu lieu, Set<Formateur> formateurs) {
		super();
		this.theme = theme;
		this.dateDebut = dateDebut;
		this.duree = duree;
		this.lieu = lieu;
		this.formateurs = formateurs;
	}

	public boolean equals(Object other) {
		// identit Objet
		if (this == other) return true;		
		if ( !(other instanceof Formation) ) return false;
		
		final Formation formation = (Formation) other;
		
		if ( !this.getId().equals( formation.getTheme() ) ) return false;
		if ( !theme.equals( formation.getTheme() ) ) return false;

		return true;
	}

	@Override
	public int hashCode() {
		// TODO Auto-generated method stub
		int result;
		result = theme.hashCode();
		result = 29 * result ;//+ created.hashCode();
		return result;

//		return super.hashCode();
	}


	
}
