package com.objis.demohibernate.service;


import java.util.Iterator;
import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.Hibernate;
import org.hibernate.Query;
import org.hibernate.Transaction;
import org.hibernate.classic.Session;
import org.hibernate.criterion.Criterion;
import org.hibernate.criterion.Order;
import org.hibernate.criterion.ProjectionList;
import org.hibernate.criterion.Projections;

import com.objis.demohibernate.domaine.Formateur;
import com.objis.demohibernate.domaine.Formation;
import com.objis.demohibernate.simple.util.HibernateUtil;


public class GestionnaireFormation {

	// Rendre persistant une formation 
	public Long creerFormation(Formation formation){

		Session session = HibernateUtil.getSessionFactory().openSession();
		Transaction tx = session.beginTransaction();

		Long formationId = null;
		try {
			session.saveOrUpdate(formation);
			tx.commit();
			formationId = formation.getId();
		} 
		catch (Exception e) {
			tx.rollback();
		} 
		finally{
			session.close();
		}

		return formationId;
	}
	
	public void testCacheSession() {
		
		// 1 : Ouverture unit de travail hibernate
		Session session = HibernateUtil.getSessionFactory().openSession();
		
		// 2 : Ouverture transaction
		Transaction tx = session.beginTransaction();

		// 3 : Rcup proxy Objet mtier Formation et manipulation Objet
		Formation formation = (Formation) session.load(Formation.class, new Long(1));
		formation.setDuree(4);
		session.saveOrUpdate(formation);
		
		// PLUS TARD DANS LA MEME SESSION HIBERNATE

		Formation formation2 = (Formation) session.load(Formation.class, new Long(1));
		formation2.setTheme("EJB3");
		session.saveOrUpdate(formation2);
		
		session.flush();
		
		// 5 : Fermeture transaction
		tx.commit();
		
		// 6 : Fermeture unit de travail hibernate
		session.close();
		
		// ---> 2 oprations de load et 2 oprations d'update... voyons voir ce qui s'affiche dans les logs...
	}

	public Formation getFormation(Long id){		
		Session session = HibernateUtil.getSessionFactory().openSession();
		// Rcup Formation (Chargement d'une formation  partir de son Id)
		Formation formation = (Formation) session.get(Formation.class,id);		
		session.close();		
		return formation;
	}
}
